# -*- coding: utf-8 -*-
from setuphelpers import *

app_uninstallkey = "Microsoft EdgeWebView"

def install():

    bin_name = glob.glob("MicrosoftEdgeWebView2RuntimeInstaller*.exe")[0]
    software_version = control.get_software_version()

    if registry_readstring(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","Publisher"):
        if not registry_readstring(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","DisplayName"):
            print("Add registry key for displayname")
            registry_set(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","DisplayName",app_uninstallkey)

    for installed in installed_softwares(app_uninstallkey):
        if Version(installed["version"], 4) >= Version(software_version, 4):
            print("Already up to date: %s (%s)" % (installed["name"], installed["version"]))
            print("Aborting installation of %s (%s)" % (installed["name"], software_version))
            return

    run(bin_name + " /silent /install",
        accept_returncodes=[0, 3010, 2147747602],
        timeout=600,
        )


##    if registry_readstring(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","Publisher"):
##        if not registry_readstring(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","DisplayName"):
##            print("Add registry key for displayname")
##            registry_set(HKEY_LOCAL_MACHINE,r"SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\Microsoft EdgeWebView","DisplayName",app_uninstallkey)

    if not uninstall_key_exists(app_uninstallkey):
        error("Error during installation")
