# -*- coding: utf-8 -*-
from setuphelpers import *
import os
import sys
import time
import glob

"""
    "update_package_dependencies": [
        "tis-wapt-selenium",
        "tis-chrome"
    ]
"""


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    update_dict = {
        "latest_bin": {
            "windows-x64": "MicrosoftEdgeWebView2RuntimeInstallerX64.exe",
            "windows-x86": "MicrosoftEdgeWebView2RuntimeInstallerX86.exe",
            "windows-arm64": "MicrosoftEdgeWebView2RuntimeInstallerARM64.exe",
        },
        "download_url": {
            "windows-x64": "https://go.microsoft.com/fwlink/?linkid=2124701",
            "windows-x86": "https://go.microsoft.com/fwlink/?linkid=2099617",
            "windows-arm64": "https://go.microsoft.com/fwlink/?linkid=2099616",
        },
    }

    latest_bin = update_dict["latest_bin"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}']
    download_url = update_dict["download_url"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}']

    version = wgets('https://developer.microsoft.com/en-us/microsoft-edge/webview2?form=MA13LH#download-section', proxies=proxies).split('Microsoft.WebView2.FixedVersionRuntime.')[1].split('.x64')[0].split('.x86')[0].split('.arm64')[0]

    # Changing version of the package

    if Version(version, 4) >= Version(control.get_software_version(), 4):
        if not isfile(makepath(basedir,latest_bin)):
            print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))

            # Downloading latest binaries
            print("Latest %s version is: %s" % (control.name, version))
            print("Download URL is: %s" % download_url)
            wget(download_url, latest_bin, proxies=proxies)
            control.set_software_version(version)
            control.save_control_to_wapt()
            package_updated = True
        else:
            print("Software version up-to-date (%s)" % Version(version))

    # Validating or not update-package-sources
    return package_updated


